@echo off
set TEMP_FILE=%1
set DBTYPE=%2
set DBHOST=""
set DBNAME=%3
set DBSCHEMA=%4
set DBPORT=%5
set USERNAME=%6
set PASSWORD=%7
for %%A in (%*) do set PROPS_FILE=%%A

mkdir %PROPS_FILE%.dir

set LOG_FILE="..\log\%PROPS_FILE%.log"
echo [%date%][%time%] "Processing started ..."> %LOG_FILE%

rem defining DBHOST
for /F "tokens=1,2 delims='='" %%i in (%PROPS_FILE%) do ( 
   if "%%i"=="SystemName" (
     for /F "tokens=1,2 delims= " %%a in ('echo %%j') do (
        set DBHOST=%%a
       )
     )
     
   if "%%i"=="SystemName " (
     for /F "tokens=1,2 delims= " %%a in ('echo %%j') do (
        set DBHOST=%%a
       )
     ) 
   )

if %DBTYPE% EQU "" (
  echo Warning: Missing Database product argument>> %LOG_FILE%
  echo [%date%][%time%] "Database product set to "DB2">> %LOG_FILE%
 set DBTYPE="DB2"
)

if %DBHOST% EQU "" (
  echo Failure: Missing DBHOST argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %DBNAME% EQU "" (
  echo Failure: Missing Database name argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %DBPORT% EQU "" (
  echo Failure: Missing Database port argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %DBSCHEMA% EQU "" (
  echo Failure: Missing Database schema argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %USERNAME% EQU "" (
  echo Failure: Missing User name argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %PASSWORD% EQU "" (
  echo Failure: Missing User password argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

if %TEMP_FILE% EQU "" (
  echo Failure: Missing OUTPUT_FILE argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

copy nul %TEMP_FILE%


for /F "delims=" %%i in ('@echo %PATH_GET%') do (set PATH_GET=%%~dpi) 

set SQLFILE="..\run\%PROPS_FILE%.dir\%PROPS_FILE%.sql"

rem for ITIM 5.0
echo SELECT %DBSCHEMA%.AUDIT_EVENT.id, %DBSCHEMA%.AUDIT_EVENT.itim_event_category, %DBSCHEMA%.AUDIT_EVENT.entity_name, %DBSCHEMA%.AUDIT_EVENT.entity_dn, %DBSCHEMA%.AUDIT_EVENT.entity_type, %DBSCHEMA%.AUDIT_EVENT.action, %DBSCHEMA%.AUDIT_EVENT.workflow_process_id, %DBSCHEMA%.AUDIT_EVENT.initiator_name, %DBSCHEMA%.AUDIT_EVENT.initiator_dn, %DBSCHEMA%.AUDIT_EVENT.container_name, %DBSCHEMA%.AUDIT_EVENT.container_dn, %DBSCHEMA%.AUDIT_EVENT.result_summary, %DBSCHEMA%.AUDIT_EVENT.timestamp, %DBSCHEMA%.AUDIT_EVENT.comments, %DBSCHEMA%.AUDIT_MGMT_TARGET.event_id as E1, %DBSCHEMA%.AUDIT_MGMT_DELEGATE.event_id as E2, %DBSCHEMA%.AUDIT_MGMT_PROVISIONING.event_id as E3, %DBSCHEMA%.AUDIT_MGMT_TARGET.target_entity_name,  %DBSCHEMA%.AUDIT_MGMT_TARGET.target_entity_dn, %DBSCHEMA%.AUDIT_MGMT_TARGET.target_entity_type, %DBSCHEMA%.AUDIT_MGMT_DELEGATE.delegate_name, %DBSCHEMA%.AUDIT_MGMT_DELEGATE.delegate_dn, %DBSCHEMA%.AUDIT_MGMT_DELEGATE.delegate_start_time, %DBSCHEMA%.AUDIT_MGMT_DELEGATE.delegate_end_time, %DBSCHEMA%.AUDIT_MGMT_PROVISIONING.owner_name, %DBSCHEMA%.AUDIT_MGMT_PROVISIONING.owner_dn, %DBSCHEMA%.AUDIT_MGMT_PROVISIONING.service_name, %DBSCHEMA%.AUDIT_MGMT_PROVISIONING.service_dn, %DBSCHEMA%.AUDIT_MGMT_PROVISIONING.access_name, %DBSCHEMA%.AUDIT_MGMT_PROVISIONING.access_dn  FROM  %DBSCHEMA%.AUDIT_EVENT left outer join %DBSCHEMA%.AUDIT_MGMT_TARGET on %DBSCHEMA%.AUDIT_EVENT.id=%DBSCHEMA%.AUDIT_MGMT_TARGET.event_id left outer join %DBSCHEMA%.AUDIT_MGMT_DELEGATE on %DBSCHEMA%.AUDIT_EVENT.id=%DBSCHEMA%.AUDIT_MGMT_DELEGATE.event_id left outer join %DBSCHEMA%.AUDIT_MGMT_PROVISIONING on %DBSCHEMA%.AUDIT_EVENT.id=%DBSCHEMA%.AUDIT_MGMT_PROVISIONING.event_id > %SQLFILE%

echo #Fields: file_with_SQLQuery;ID;ITIM_EVENT_CATEGORY;ENTITY_NAME;ENTITY_DN;ENTITY_TYPE;ACTION;WORKFLOW_PROCESS_ID;INITIATOR_NAME;INITIATOR_DN;CONTAINER_NAME;CONTAINER_DN;RESULT_SUMMARY;TIMESTAMP;COMMENTS;E1;E2;E3;TARGET_ENTITY_NAME;TARGET_ENTITY_DN;TARGET_ENTITY_TYPE;DELEGATE_NAME;DELEGATE_DN;DELEGATE_START_TIME;DELEGATE_END_TIME;OWNER_NAME;OWNER_DN;SERVICE_NAME;SERVICE_DN;ACCESS_NAME;ACCESS_DN; > %TEMP_FILE%
java.exe -Dfile.encoding=UTF-8 -classpath "%JDBCDRIVERPATH%;../bin/jdbc-genact.jar" eprise.audit.chunktool.generic.java.JdbcGenact -driver=%DBTYPE% -host="%DBHOST%" -port="%DBPORT%" -database="%DBNAME%" -username="%USERNAME%" -passwd="%PASSWORD%" -props="%PROPS_FILE%" -outfilename="%TEMP_FILE%" -sqlfilename="%SQLFILE%" -useheaderline=no  -separator=";" -eraseoutfile=no -tdcolumn=timestamp -timecolumntype="string" -datetimeformat="yyyy-MM-dd HH:mm:ss:000 'GMT'" >> %LOG_FILE%

if %ERRORLEVEL% NEQ 0 (
 echo %date% %time% Unable to collect the data from ITIM 5.0.>> %LOG_FILE%
 ) else (GOTO finish)
 
rem for ITIM 4.6
echo %date% %time% Trying to collect the data from ITIM 4.6.>> %LOG_FILE%

echo SELECT %DBSCHEMA%.AUDIT_EVENT.id, %DBSCHEMA%.AUDIT_EVENT.itim_event_category, %DBSCHEMA%.AUDIT_EVENT.entity_name, %DBSCHEMA%.AUDIT_EVENT.entity_dn, %DBSCHEMA%.AUDIT_EVENT.entity_type, %DBSCHEMA%.AUDIT_EVENT.action, %DBSCHEMA%.AUDIT_EVENT.workflow_process_id, %DBSCHEMA%.AUDIT_EVENT.initiator_name, %DBSCHEMA%.AUDIT_EVENT.initiator_dn, %DBSCHEMA%.AUDIT_EVENT.container_name, %DBSCHEMA%.AUDIT_EVENT.container_dn, %DBSCHEMA%.AUDIT_EVENT.result_summary, %DBSCHEMA%.AUDIT_EVENT.timestamp, %DBSCHEMA%.AUDIT_EVENT.comments, %DBSCHEMA%.AUDIT_MGMT_TARGET.event_id as E1, %DBSCHEMA%.AUDIT_MGMT_DELEGATE.event_id as E2, %DBSCHEMA%.AUDIT_MGMT_PROVISIONING.event_id as E3, %DBSCHEMA%.AUDIT_MGMT_TARGET.target_entity_name,  %DBSCHEMA%.AUDIT_MGMT_TARGET.target_entity_dn, %DBSCHEMA%.AUDIT_MGMT_TARGET.target_entity_type, %DBSCHEMA%.AUDIT_MGMT_DELEGATE.delegate_name, %DBSCHEMA%.AUDIT_MGMT_DELEGATE.delegate_dn, %DBSCHEMA%.AUDIT_MGMT_DELEGATE.delegate_start_time, %DBSCHEMA%.AUDIT_MGMT_DELEGATE.delegate_end_time, %DBSCHEMA%.AUDIT_MGMT_PROVISIONING.owner_name, %DBSCHEMA%.AUDIT_MGMT_PROVISIONING.owner_dn, %DBSCHEMA%.AUDIT_MGMT_PROVISIONING.service_name, %DBSCHEMA%.AUDIT_MGMT_PROVISIONING.service_dn FROM %DBSCHEMA%.AUDIT_EVENT left outer join %DBSCHEMA%.AUDIT_MGMT_TARGET on %DBSCHEMA%.AUDIT_EVENT.id=%DBSCHEMA%.AUDIT_MGMT_TARGET.event_id left outer join %DBSCHEMA%.AUDIT_MGMT_DELEGATE on %DBSCHEMA%.AUDIT_EVENT.id=%DBSCHEMA%.AUDIT_MGMT_DELEGATE.event_id left outer join %DBSCHEMA%.AUDIT_MGMT_PROVISIONING on %DBSCHEMA%.AUDIT_EVENT.id=%DBSCHEMA%.AUDIT_MGMT_PROVISIONING.event_id > %SQLFILE%

echo #Fields: file_with_SQLQuery;ID;ITIM_EVENT_CATEGORY;ENTITY_NAME;ENTITY_DN;ENTITY_TYPE;ACTION;WORKFLOW_PROCESS_ID;INITIATOR_NAME;INITIATOR_DN;CONTAINER_NAME;CONTAINER_DN;RESULT_SUMMARY;TIMESTAMP;COMMENTS;E1;E2;E3;TARGET_ENTITY_NAME;TARGET_ENTITY_DN;TARGET_ENTITY_TYPE;DELEGATE_NAME;DELEGATE_DN;DELEGATE_START_TIME;DELEGATE_END_TIME;OWNER_NAME;OWNER_DN;SERVICE_NAME;SERVICE_DN; > %TEMP_FILE%
java.exe -Dfile.encoding=UTF-8 -classpath "%JDBCDRIVERPATH%;../bin/jdbc-genact.jar" eprise.audit.chunktool.generic.java.JdbcGenact -driver=%DBTYPE% -host="%DBHOST%" -port="%DBPORT%" -database="%DBNAME%" -username="%USERNAME%" -passwd="%PASSWORD%" -props="%PROPS_FILE%" -outfilename="%TEMP_FILE%" -sqlfilename="%SQLFILE%" -useheaderline=no  -separator=";" -eraseoutfile=no -tdcolumn=timestamp -timecolumntype="string" -datetimeformat="yyyy-MM-dd HH:mm:ss:000 'GMT'" >> %LOG_FILE%

if %errorlevel% NEQ 0 (
  echo Failure: Collect process failed>> %LOG_FILE%
  echo [%date%][%time%] "Failure collecting audit trail.">> %LOG_FILE%
  rmdir %PROPS_FILE%.dir /S /q
  exit /b 1
) else (GOTO finish)

:finish
echo [%date%][%time%] "Success: Processing finished" >> %LOG_FILE%

rmdir %PROPS_FILE%.dir /S /q
exit /b 0