@echo off

rem set of vars from the command line
set TEMP_FILE1=%1
set TEMP_FILE2=%2
set TEMP_FILE3=%3
set DB_PORT=%4
set DB_NAME=%5
set USER=%6
set PASS=%7
for %%A in (%*) do set PROPS_FILE=%%A

rem set of  vars for *.sql filename
set ADMIN_SQL_FILE=admin.sql_%PROPS_FILE%
set ERROR_SQL_FILE=error.sql_%PROPS_FILE%
set VIOLATION_SQL_FILE=viloation.sql_%PROPS_FILE%

rem ReturnCode = 0  , +1 - error ADMIN_LOG, +10 - error ERROR.LOG, +100 - error VIOLATIONS_LOG
set /A ReturnCode=0

rem actuator progress log file name
set LOG_FILE="..\log\%PROPS_FILE%.log"

rem create actuator progress file name and write the first 
type nul > %LOG_FILE%
echo [%date%][%time%] Processing started ...> %LOG_FILE%

rem verify TEMP_FILE1 propeprty
if %TEMP_FILE1% EQU "" (
echo 3
    echo [%date%][%time%] Failure: Missing argument TEMPFILE1 >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)

rem verify TEMP_FILE2 propeprty
if %TEMP_FILE2% EQU "" (
    echo [%date%][%time%] Failure: Missing argument TEMPFILE2 >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)

rem verify TEMP_FILE3 propeprty
if %TEMP_FILE3% EQU "" (
    echo [%date%][%time%] Failure: Missing argument TEMPFILE3 >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)

rem verify DB_PORT propeprty
if %DB_PORT% EQU "" (
    echo [%date%][%time%] Failure: Data Base Port >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)

rem verify USER propeprty
if %USER% EQU "" (
    echo [%date%][%time%] Failure: Missing argument USER >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)

rem !!! we do not check PASS property (user password) !!!

rem verify PROPS_FILE  propeprty
if %PROPS_FILE% EQU "" (
    echo [%date%][%time%] Failure: Missing argument PROPS_FILE >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)

set HOST_NAME="empty"
rem obtain "SystemName" (host name)
if exist %PROPS_FILE% (
  findstr "SystemName" %PROPS_FILE%> nul
  if NOT errorlevel 1 (
    for /F "tokens=1,2 delims== " %%i in ('findstr "SystemName" %PROPS_FILE%') do (
     set HOST_NAME=%%j
    )
  ) 
) 

rem SQL-query for ADMIN_LOG:
echo SELECT tb2.userid, tb1.* from jac_sys.admin_log tb1 left outer join jac_sys.users tb2 on tb1.use_id=tb2.use_id order by tb1.logdate > %ADMIN_SQL_FILE%

rem call jdbc-genact with all needed parameters to obtain ADMIN_LOG audit info
call java -classpath "%CLASSPATH%;db2jcc.jar;db2jcc_license_cu.jar;sqljdbc.jar;../bin/jdbc-genact.jar" -Dfile.encoding=UTF-8 eprise.audit.chunktool.generic.java.JdbcGenact -driver="DB2" -host=%HOST_NAME% -port=%DB_PORT% -database="JAC" -username=%USER% -passwd=%PASS% -props=%PROPS_FILE% -outfilename=%TEMP_FILE1% -sqlfilename=%ADMIN_SQL_FILE% -useheaderline=YES -tdcolumn="logdate" -idcolumn="" -separator=";" -datetimeformat="yyyy-MM-dd HH:mm:ss" -eraseoutfile=YES >> %LOG_FILE%

rem verify result of jdbc-genact
if %errorlevel% NEQ 0 (
  set /A ReturnCode=1
  echo Warning: Collect from table JAC_SYS.ADMIN_LOG is finished [FAILURE] >> %LOG_FILE%
) else (
  echo Collect from table JAC_SYS.ADMIN_LOG is finished [SUCCESS] >> %LOG_FILE%
)

rem delete admin.sql file
del /Q %ADMIN_SQL_FILE%


rem SQL-query for ERROR_LOG:
echo SELECT el.*, cl.alias, 'error_log' as tblname from jac_data.error_log el left outer join jac_sys.clients cl on el.cli_id=cl.cli_id order by el.logdate > %ERROR_SQL_FILE%

rem call jdbc-genact with all needed parameters to obtain ERROR_LOG audit info
call java -classpath "%CLASSPATH%;db2jcc.jar;db2jcc_license_cu.jar;sqljdbc.jar;../bin/jdbc-genact.jar" -Dfile.encoding=UTF-8 eprise.audit.chunktool.generic.java.JdbcGenact -driver="DB2" -host=%HOST_NAME% -port=%DB_PORT% -database="JAC" -username=%USER% -passwd=%PASS% -props=%PROPS_FILE% -outfilename=%TEMP_FILE2% -sqlfilename=%ERROR_SQL_FILE% -useheaderline=YES -tdcolumn="logdate" -idcolumn="" -separator=";" -datetimeformat="yyyy-MM-dd HH:mm:ss" -eraseoutfile=YES >> %LOG_FILE%

rem verify result of jdbc-genact
if %errorlevel% NEQ 0 (
  set /A ReturnCode=%ReturnCode%+10
  echo Warning: Collect from JAC_DATA.ERROR_LOG is finished [FAILURE] >> %LOG_FILE%
) else (
  echo Collect from table JAC_DATA.ERROR_LOG is finished [SUCCESS] >> %LOG_FILE%
)

rem delete sql file
del /Q %ERROR_SQL_FILE%


rem SQL-query for VIOLATIONS:
echo SELECT snap.rundate, pol.name as POLNAME, comp.name as COMPNAME, cl.alias, vio.* from jac_sys.violations as vio left outer join jac_sys.snapshots as snap on vio.sna_id=snap.id left outer join jac_sys.clients as cl on vio.cli_id=cl.cli_id left outer join jac_sys.policies as pol on snap.pol_id=pol.id left outer join jac_sys.compliance_sql as comp on vio.com_id=comp.id order by snap.rundate > %VIOLATION_SQL_FILE%

rem call jdbc-genact with all needed parameters to obtain VIOLATION_FILE audit info
call java -classpath "%CLASSPATH%;db2jcc.jar;db2jcc_license_cu.jar;sqljdbc.jar;../bin/jdbc-genact.jar" -Dfile.encoding=UTF-8 eprise.audit.chunktool.generic.java.JdbcGenact -driver="DB2" -host=%HOST_NAME% -port=%DB_PORT% -database="JAC" -username=%USER% -passwd=%PASS% -props=%PROPS_FILE% -outfilename=%TEMP_FILE3% -sqlfilename=%VIOLATION_SQL_FILE% -useheaderline=YES -tdcolumn="rundate" -idcolumn="" -separator=";" -datetimeformat="yyyy-MM-dd HH:mm:ss" -eraseoutfile=YES >> %LOG_FILE%

rem verify result of jdbc-genact
if %errorlevel% NEQ 0 (
  set /A ReturnCode+=100
  echo Warning: Collect from JAC_SYS.VIOLATIONS is finished [FAILURE] >> %LOG_FILE%
) else (
  echo Collect from table JAC_SYS.VIOLATIONS is finished [SUCCESS] >> %LOG_FILE%
)

rem delete sql file
del /Q %VIOLATION_SQL_FILE%

echo ReturnCode = %ReturnCode%

if %ReturnCode% EQU 111 (
  echo [%date%][%time%] Processing finished. [FAILURE] >> %LOG_FILE%
  exit /b 1
) else (
  echo [%date%][%time%] Processing finished. [SUCCESS] >> %LOG_FILE%
  exit /b 0
)
