REM Licensed Materials - Property of IBM
REM 5724-S67
REM (c) Copyright IBM Corp. 1998, 2007   All Rights Reserved.
REM US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
set TEMP_FILE1=%1
set TEMP_FILE2=%2
set CLEANUP=%3
set TRACE_PATH=%4
set USER_NAME=%5
set PASSWORD=%6
set PROPS_FILE=%7

type nul > ..\log\%PROPS_FILE%.log

if "%TEMP_FILE1%" EQU "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  exit /b 88
)           
if "%TEMP_FILE2%" EQU "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  exit /b 88
)
if %TRACE_PATH% EQU "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  exit /b 88
)
if "%USER_NAME%" EQU "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  exit /b 88
)

@echo %date% %time% "Processing started" >> ..\log\%PROPS_FILE%.log
mkdir %PROPS_FILE%.dir

rem -------------------------------------------------------------------------------------------------------------------
rem Perform a list of root trc files. This list won't contain any offsprings (i.e. audittrace_20080830000000_X.trc, audittrace_20080830000000_XX.trc, etc.)
dir /ON /A-D /B /S %TRACE_PATH%\audittrace* | findstr /V "audittrace[_]*[0-9][0-9]*_[0-9]*.trc" > %PROPS_FILE%.dir\listing.%PROPS_FILE%
@echo %date% %time% "Created listing of available Audit traces" >> ..\log\%PROPS_FILE%.log

if EXIST %PROPS_FILE% (
  for /F "delims=," %%I in ('findstr /V audittrace %PROPS_FILE%') DO (set LINE_NUM=%%I)
  for /F "delims=," %%I in ('findstr "audittrace[_]*[0-9][0-9]*.trc" %PROPS_FILE%') DO (set PREV_FILE=%%I)
  for /F "delims=," %%I in ('findstr "audittrace[_]*[0-9][0-9]*_[0-9]*.trc" %PROPS_FILE%') DO (set LAST_PACKAGED_FILE=%%I)
)

if "%PREV_FILE%" == "" (
  goto FC
) else (
  goto NONFC
)

rem -------------------------------------------------------------------------------------------------------------------
:NONFC
rem LAST_PACKAGED_FILE can be empty in case, when the value doesn't have the underscored character.
rem In this case the value of LAST_PACKAGED_FILE is the save as PREV_FILE
if "%LAST_PACKAGED_FILE%" EQU "" (
  set LAST_PACKAGED_FILE=%PREV_FILE%
)

@echo %date% %time% "Properties file contents: %PREV_FILE% %LINE_NUM% %LAST_PACKAGED_FILE%" >> ..\log\%PROPS_FILE%.log
type nul>%PROPS_FILE%.dir\list
set /a OLD=%LINE_NUM%

rem Check if we have connection to the MSSQL server
for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO (
  bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', default)" QUERYOUT "%PROPS_FILE%.dir\tmp.txt" -U%USER_NAME% -P%PASSWORD% -f../bin/format.fmt -F 1 -L 2
  goto NEXT1
)
:NEXT1
if %errorlevel% NEQ 0 (
  @echo %date% %time% "ERROR: Could not connect to MS SQL Server (Return code 1)" >> ..\log\%PROPS_FILE%.log
  GOTO EXIT
)
rem End check

for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO (
  if "%PREV_FILE%" EQU "%%I" (
    bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', default)" QUERYOUT "%PROPS_FILE%.dir\%%~nI.txt" -U%USER_NAME% -P%PASSWORD% -f../bin/format.fmt -F%LINE_NUM%
    if %errorlevel% NEQ 0 (
      @echo %date% %time% "WARNING: File %%I is empty" >> ..\log\%PROPS_FILE%.log
    )

    echo "%%I">>%PROPS_FILE%.dir\list
    @echo %date% %time% "Collect data from Audit trace %%~nI" >> ..\log\%PROPS_FILE%.log
    type "%PROPS_FILE%.dir\%%~nI.txt" >> %TEMP_FILE1%
  )

  if "%PREV_FILE%" LSS "%%I" (
    bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', default)" QUERYOUT "%PROPS_FILE%.dir\%%~nI.txt" -U%USER_NAME% -P%PASSWORD% -f../bin/format.fmt
    if %errorlevel% NEQ 0 (
      @echo %date% %time% "WARNING: File %%I is empty" >> ..\log\%PROPS_FILE%.log
    )
    echo "%%I">>%PROPS_FILE%.dir\list
    @echo %date% %time% "Collect data from Audit trace %%~nI" >> ..\log\%PROPS_FILE%.log
    type "%PROPS_FILE%.dir\%%~nI.txt" >> %TEMP_FILE1%
    set /a OLD=0
  )
  set LAST_TRACE_FILE_NAME=%%I
  set COUNT_VAL=%PROPS_FILE%.dir\%%~nI.txt
)


echo %LAST_TRACE_FILE_NAME%>%PROPS_FILE%
set /a I=1
for /F "tokens=*" %%I in (%COUNT_VAL%) do (
  set /a I=I+1
)
set /a I=I+OLD
echo "%I%">>%PROPS_FILE%
goto TAR:


rem -------------------------------------------------------------------------------------------------------------------
:FC
rem Check if we have connection to the MSSQL server
for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO (
  bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', default)" QUERYOUT "%PROPS_FILE%.dir\tmp.txt" -U%USER_NAME% -P%PASSWORD% -f../bin/format.fmt -F 1 -L 2
  goto NEXT2
)
:NEXT2
if %errorlevel% NEQ 0 (
  @echo %date% %time% "ERROR: Could not connect to MS SQL Server (Return code 1)" >> ..\log\%PROPS_FILE%.log
  GOTO EXIT
)

rem End check

rem Dump .trc files to .txt files
for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO (
  bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', default)" QUERYOUT "%PROPS_FILE%.dir\%%~nI.tmp" -U%USER_NAME% -P%PASSWORD% -f../bin/format.fmt
  
  if %errorlevel% NEQ 0 (
    @echo %date% %time% "WARNING: File %%I is empty" >> ..\log\%PROPS_FILE%.log
  )
  
  rem If file's size is 0
  for /F "delims=," %%K IN ('echo %PROPS_FILE%.dir\%%~nI.tmp') do (
    if %%~zK GTR 0 (
      @echo %PROPS_FILE%.dir\%%~nI.tmp>>%PROPS_FILE%.dir\all_events_list
    ) else (
      @echo %date% %time% "WARNING: Audit trace %%~nI is empty." >> ..\log\%PROPS_FILE%.log
    )
  )
  
  set LAST_TRACE_FILE_NAME=%%I
)

rem Save the name of the latest .trc file we have processed
echo %LAST_TRACE_FILE_NAME%>%PROPS_FILE%

rem Determines the date, from which we should start collecting with (Current date - 2 days)
for /F "delims=," %%I IN ('..\bin\date +%%Y-%%m-%%d -d "2 days ago"') DO (
  set START_COLLECT_FROM_DATE=%%I
)

rem Create txt files with actual events
set EXECUTABLE=cscript.exe //B //NoLogo ..\bin\MssqlFirstCollect.vbs
call %EXECUTABLE% "%PROPS_FILE%" "%START_COLLECT_FROM_DATE%" "%TEMP_FILE1%"

goto TAR:

rem -------------------------------------------------------------------------------------------------------------------
:TAR
if "%TEMP_FILE2%" EQU "6" (
  goto T:
)

rem Make a list with all trc files (include offsprings)
for /F "delims=," %%I in ('type %PROPS_FILE%.dir\list') do (
  dir /ON /A-D /B /S "%%~dpI\%%~nI"* >> %PROPS_FILE%.dir\listall.unsorted
)

rem Sort a list with trc files
..\bin\tcimsort -mssql -o %PROPS_FILE%.dir\listall.sorted %PROPS_FILE%.dir\listall.unsorted

rem Make an archive with trc files
set SHOULD_BE_ARCHIVED=no

if "%LAST_PACKAGED_FILE%" EQU "" (
  set SHOULD_BE_ARCHIVED=yes
)

for /F "delims=," %%I in ('type %PROPS_FILE%.dir\listall.sorted') do (
  if "%LAST_PACKAGED_FILE%" EQU "%%I" (    
    call :EVALUATE_SHOULD_BE_ARCHIVED
  )  
  
  call :ARCHIVE "%%I"
)

@echo %LAST_PACKAGED_FILE%>>%PROPS_FILE%

@echo %date% %time% "Original logs archive created" >> ..\log\%PROPS_FILE%.log
goto T:

rem -------------------------------------------------------------------------------------------------------------------
:T

del /Q %PROPS_FILE%.dir\listall
if "%CLEANUP%" EQU "yes" (
  @echo %date% %time% "Cleanup requested. Cleanning..." >> ..\log\%PROPS_FILE%.log
  for /F "delims=," %%I in ('type %PROPS_FILE%.dir\list') do (
    dir /ON /A-D /B /S "%%~dpI\%%~nI"*>>%PROPS_FILE%.dir\listall
  )
  for /F "delims=," %%I in ('type .\%PROPS_FILE%.dir\listall') DO (
    if "%%I" LSS "%LAST_TRACE_FILE_NAME%" (
      del /Q "%%~dpI"\"%%~nI*"
    )
  )
  @echo %date% %time% "Cleanup finished" >> ..\log\%PROPS_FILE%.log
)
@echo %date% %time% "Processing finished (Return code 0)" >> ..\log\%PROPS_FILE%.log
rmdir /S /Q %PROPS_FILE%.dir
exit /b 0

rem -------------------------------------------------------------------------------------------------------------------
:EXIT
rmdir /S /Q %PROPS_FILE%.dir
exit /b 1


:EVALUATE_SHOULD_BE_ARCHIVED
set SHOULD_BE_ARCHIVED=yes
goto :EOF

:ARCHIVE
set CURRENT_FILE=%~1
  if "%SHOULD_BE_ARCHIVED%" EQU "yes" (
    if EXIST %TEMP_FILE2% (
        ..\bin\bsdtar.exe -rf %TEMP_FILE2% "%CURRENT_FILE%"
    ) ELSE (
        ..\bin\bsdtar.exe -cf %TEMP_FILE2% "%CURRENT_FILE%"
    )
    set LAST_PACKAGED_FILE=%CURRENT_FILE%
  )
goto :EOF
